<?php
require "php-pecl/consumer_key.php";
require "php-pecl/api_url_base.php";
require "php-pecl/error.php";

function buildBaseString($baseURI, $method, $params) {
    $r = array();
    ksort($params);
    foreach($params as $consumer_key=>$value){
        $r[] = "$consumer_key=" . rawurlencode($value);
    }
    return $method .'&'. rawurlencode($baseURI) .'&'. rawurlencode(implode('&', $r));
}

function buildAuthorizationHeader($oauth) {
    $r = 'Authorization: OAuth ';
    $values = array();
    foreach($oauth as $consumer_key=>$value)
        $values[] = "$consumer_key=\"" . rawurlencode($value) . "\"";
    $r .= implode(', ', $values);
    return $r;
}	

$pin = readline("Pin: ");

# Get an access token
//echo "\nRequesting an access token.\n";
$link = "/v2/oauth/access_token";

$timestamp = time();
$signature_method="HMAC-SHA1";
unset($oauth);
$oauth_token=$_GET['oauth_token'];
$pin=$_GET['oauth_verifier'];
$oauth_token_secret = "c0a6f910ea";
$oauth = array(
    'oauth_consumer_key' => $consumer_key,
    'oauth_signature_method' => $signature_method,
    'oauth_nonce' => time(),
    'oauth_timestamp' => $timestamp,
    'oauth_version' => '1.0',
    'oauth_token' => $oauth_token,
    'oauth_verifier' => $pin,
    );
$url = $api_url_base . $link;
$base_info = buildBaseString($url, 'GET', $oauth);
$composite_key = rawurlencode($consumer_secret) . '&' . rawurlencode($oauth_token_secret);
$oauth_signature = base64_encode(hash_hmac('sha1', $base_info, $composite_key, true));
$oauth['oauth_signature'] = $oauth_signature;

$oauthString = "";
foreach($oauth as $key=>$value) {
    $stringKey = rawurlencode($key);
    $stringValue = rawurlencode($value);
    if (strlen($oauthString) == 0) {
        $oauthString .= "?";
    } else {
        $oauthString .= "&";
    }
    $oauthString .= "$stringKey=$stringValue";
}

$url .= $oauthString;

$options = array(
    CURLOPT_HEADER => false,
    CURLOPT_URL => $url,
    //CURLOPT_PORT => 80,
    CURLOPT_RETURNTRANSFER => true);
$ch = curl_init();
curl_setopt_array($ch, $options);
$result = curl_exec($ch);
if ( ! $result ) {
    echo "Curl error :\n". curl_error($ch) . "\n";
} else {
    $oauth_token="";
    $oauth_token_secret="";
    $resultArray=parse_url(rawurldecode($result));
    //parse_str($resultArray["path"]);
    //parse_str($resultArray["query"]);
}
?>
<textarea rows="25" cols="50"><?php print_r($result); ?></textarea>
<?php
curl_close($ch);
?>
